C*******************************************************************************
      SUBROUTINE BGT1AL(ISUMRX,ISUMIR,LCBGT,LKBGT,LZBGT,LPBGT,
     &  NBGT,NBGTI,NBGTP,CUNIT,IUNIT,LUNIT,NIUNIT,
     &  IBGTUN,NCOL,NROW,NLAY,IN,IOUT)
C
C-----VERSION 02DEC2004 BGT1AL
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR BUDGETS
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      DIMENSION    IUNIT(NIUNIT),LUNIT(NIUNIT)
      CHARACTER*4  CUNIT(NIUNIT)
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
C
C1------IDENTIFY PROGRAM.
      WRITE(IOUT,'(A,I3)') ' BUDGET VERSION 1.0, INPUT FROM UNIT',IN
C2------READ NUMBER OF BUDGET ZONES AND UNIT FOR SAVING UNFORMATTED
C2------BUDGET FILE TO BE SAVED IN HYDROGRAPH FORMAT
      READ(IN,'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NBGT,R,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IBGTUN,R,IOUT,IN)
      WRITE(IOUT,'(A,I6)') ' NUMBER OF BUDGET ZONES',NBGT
      WRITE(IOUT,'(A,I6)') ' BUDGETS SAVED TO UNIT ',IBGTUN
      NBGT = NBGT+1
C
C3------ALLOCATE MEMORY FOR BUDGET ITEMS
      LCBGT  = ISUMRX
      ISUMRX = ISUMRX + 2*NBGT
      LKBGT  = ISUMRX
      ISUMRX = ISUMRX + 2*NBGT
      NBGTP = 2
      DO L=1,NIUNIT
        IF (IUNIT(L).gt.0 .AND.
     |      (CUNIT(L).eq.'WEL ' .OR. CUNIT(L).eq.'DRN ' .OR.
     |       CUNIT(L).eq.'RIV ' .OR. CUNIT(L).eq.'EVT ' .OR.
     |       CUNIT(L).eq.'GHB ' .OR. CUNIT(L).eq.'DRT ' .OR.
     |       CUNIT(L).eq.'FHB ' .OR. CUNIT(L).eq.'RES ' .OR.
     |       CUNIT(L).eq.'STR ' .OR. CUNIT(L).eq.'IBS ' .OR.
     |       CUNIT(L).eq.'CHD ' .OR. CUNIT(L).eq.'LAK ' .OR.
     |       CUNIT(L)(1:3).eq.'ETS' .OR. CUNIT(L)(1:3).eq.'RCH')) THEN
          LUNIT(L) = ISUMRX
          ISUMRX = ISUMRX + 2*NBGT
          NBGTP = NBGTP+1
        ELSE
          LUNIT(L) = 0
        ENDIF
      ENDDO
      ISUMRX = ISUMRX + NBGT**2
      NBGTI = ISUMRX-LCBGT
C
C4------ALLOCATE MEMORY FOR ZONE INDICATOR ARRAY
      LZBGT = ISUMIR
      ISUMIR  = ISUMIR+NROW*NCOL*NLAY
      LPBGT = ISUMIR
      ISUMIR  = ISUMIR+NBGT**2
C
C5------PRINT AMOUNT OF SPACE USED BY THE BUDGET
      WRITE(IOUT,'(1X,I8,A)')
     |  ISUMRX-LCBGT,' ELEMENTS IN RX ARRAY USED FOR BUDGET'
      WRITE(IOUT,'(1X,I8,A)')
     |  ISUMIR-LZBGT,' ELEMENTS IN IR ARRAY USED FOR BUDGET'
C6------RETURN
      RETURN
      END
C========================================================================
      SUBROUTINE BGT1RP(LZBGT,LPBGT,NBGT,NBGTI,IBGTUN,ITMUNI,BGTMUL,
     |                  CUNIT,LUNIT,NIUNIT,NCOL,NROW,NLAY,IN,IOUT)
C-----VERSION 02DEC2004 BGT1RP
C     ******************************************************************
C     READ ZONE DATA FOR BUDGETS
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      PARAMETER    (MAXBGT=8192)
      DIMENSION    LZBGT(NCOL,NROW,NLAY),LUNIT(NIUNIT),IDZONE(MAXBGT)
      DIMENSION    LPBGT(NBGT,NBGT)
      CHARACTER*4  TIMLBL,CUNIT(NIUNIT)
      CHARACTER*8  ZONLBL(MAXBGT)
      CHARACTER*20 BGTLBL(MAXBGT)
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
C
      IF (NBGTI.GT.MAXBGT) STOP 'Recompile with larger MAXBGT'
C  Read rate/volume and multiplier
      READ(IN,'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF (LINE(ISTART:ISTOP).EQ.'RATE') THEN
        MUL = 1
      ELSE IF (LINE(ISTART:ISTOP).EQ.'VOLUME') THEN
        MUL = -1
      ELSE
        WRITE(IOUT,'(2A)') ' INVALID BUDGET TYPE ',LINE(ISTART:ISTOP)
        STOP
      ENDIF
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,BGTMUL,IOUT,IN)
      IF (BGTMUL.LE.0) THEN
        WRITE(IOUT,'(A)') ' INVALID BUDGET MULTIPLIER'
        STOP
      ENDIF
      BGTMUL = MUL*BGTMUL
C  Read the zone IDs and names
      DO L=1,NBGT-1
        READ(IN,'(A)') LINE
        LLOC=1
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IDZONE(L),R,IOUT,IN)
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
        ZONLBL(L) = LINE(ISTART:ISTOP)
      ENDDO
C  Read the name for the 'other' zone
      READ(IN,'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      ZONLBL(NBGT) = LINE(ISTART:ISTOP)
C  Read zone identifiers
      DO K=1,NLAY
        CALL U2DINT(LZBGT(1,1,K),'BUDGET ZONE IDENTIFIERS ',
     |              NROW,NCOL,K,IN,IOUT)
      ENDDO
C  Translate zone identifiers to index 
      DO K=1,NLAY
        DO I=1,NROW
          DO J=1,NCOL
            DO L=1,NBGT-1
              if (LZBGT(J,I,K).eq.IDZONE(L)) GOTO 100
            ENDDO
            L = NBGT
100         LZBGT(J,I,K) = L
          ENDDO
        ENDDO
      ENDDO
C  Identify adjacent zones
      DO M=1,NBGT
        DO L=1,NBGT
          LPBGT(L,M) = 0
        ENDDO
      ENDDO
      DO K=1,NLAY
        DO I=1,NROW
          DO J=1,NCOL-1
            L0 = LZBGT(J,I,K)
            L1 = LZBGT(J+1,I,K)
            LPBGT(L0,L1) = 1
            LPBGT(L1,L0) = 1
          ENDDO
        ENDDO
      ENDDO
      DO K=1,NLAY
        DO I=1,NROW-1
          DO J=1,NCOL
            L0 = LZBGT(J,I,K)
            L1 = LZBGT(J,I+1,K)
            LPBGT(L0,L1) = 1
            LPBGT(L1,L0) = 1
          ENDDO
        ENDDO
      ENDDO
      DO K=1,NLAY-1
        DO I=1,NROW
          DO J=1,NCOL
            L0 = LZBGT(J,I,K)
            L1 = LZBGT(J,I,K+1)
            LPBGT(L0,L1) = 1
            LPBGT(L1,L0) = 1
          ENDDO
        ENDDO
      ENDDO
C  Set up budget item labels
      NBGTI = 0
      DO M=1,NBGT
        NBGTI = NBGTI+1
        BGTLBL(NBGTI) = 'STOi'//ZONLBL(M)
        NBGTI = NBGTI+1
        BGTLBL(NBGTI) = 'STOo'//ZONLBL(M)
      ENDDO
      DO M=1,NBGT
        NBGTI = NBGTI+1
        BGTLBL(NBGTI) = 'CHDi'//ZONLBL(M)
        NBGTI = NBGTI+1
        BGTLBL(NBGTI) = 'CHDo'//ZONLBL(M)
      ENDDO
      DO L=1,NIUNIT
        IF (LUNIT(L).gt.0) then
          LN = LENGTH(CUNIT(L))
          DO M=1,NBGT
            NBGTI = NBGTI+1
            BGTLBL(NBGTI) = CUNIT(L)(1:LN)//'i'//ZONLBL(M)
            NBGTI = NBGTI+1
            BGTLBL(NBGTI) = CUNIT(L)(1:LN)//'o'//ZONLBL(M)
          ENDDO
        ENDIF
      ENDDO
      DO L=1,NBGT
        NBGTI = NBGTI+1
        BGTLBL(NBGTI) = 'Res'//ZONLBL(L)
      ENDDO
      DO L=1,NBGT
        LN = LENGTH(ZONLBL(L))
        DO M=1,NBGT
          IF (L.NE.M .and. LPBGT(L,M).NE.0) THEN
            NBGTI = NBGTI+1
            LPBGT(L,M) = NBGTI
            BGTLBL(NBGTI) = ZONLBL(L)(1:LN)//'_'//ZONLBL(M)
          ELSE
            LPBGT(L,M) = 0
          ENDIF
        ENDDO
      ENDDO
C  Set up HYDMOD header
      TIMLBL='TIME'
      WRITE(IBGTUN) NBGTI,ITMUNI
      WRITE(IBGTUN) TIMLBL,(BGTLBL(L),L=1,NBGTI)
      END
C========================================================================
      SUBROUTINE BGT1BD(BGT,NBGTI)
C-----VERSION 02DEC2004 BGT1BD
C     ******************************************************************
C     INITIALIZE BUDGET RECORD
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      DIMENSION BGT(NBGTI)
C     ------------------------------------------------------------------
C  Calculate residuals by zone
      DO L=1,NBGTI
        BGT(L) = 0
      ENDDO
      END
C========================================================================
      SUBROUTINE BGT1OT(BGT,LPBGT,BGTMUL,DELT,
     |                  NBGT,NBGTI,NBGTP,TOTIM,IBGTUN)
C-----VERSION 02DEC2004 BGT1RP
C     ******************************************************************
C     WRITE BUDGET RECORD
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      DIMENSION BGT(NBGTI),LPBGT(NBGT,NBGT)
C     ------------------------------------------------------------------
C  Calculate residuals by zone
      N = 2*NBGTP*NBGT
      DO L=1,NBGT
        I = N+L
        BGT(I) = 0
        DO J=2*(L-1),N-1,2*NBGT
          BGT(I) = BGT(I) + BGT(J+1) - BGT(J+2)
        ENDDO
        DO M=1,NBGT
          IF (LPBGT(L,M).GT.0) BGT(I) = BGT(I) - BGT(LPBGT(L,M))
          IF (LPBGT(M,L).GT.0) BGT(I) = BGT(I) + BGT(LPBGT(M,L))
        ENDDO
      ENDDO
C  Output budget
      IF (BGTMUL.LT.0) THEN
        CONV = -BGTMUL*DELT
      ELSE
        CONV = BGTMUL
      ENDIF
      WRITE(IBGTUN) TOTIM,(CONV*BGT(L),L=1,NBGTI)
      END
C========================================================================
      FUNCTION LENGTH(STRING)
      CHARACTER*(*) STRING
      DO L=LEN(STRING),1,-1
        IF (STRING(L:L).ne.' ') GOTO 999
      ENDDO
      L = 1
999   LENGTH = L
      END
