C***********************************************************************
C***  Read parameters for saturated thickness relaxation
C***********************************************************************
      SUBROUTINE RELAX1AL(ISUMRX,LCRLX,STRLX,STMIN,STMAX,NODES,IN,IOUT)
      CHARACTER*80 LINE

C1------IDENTIFY PROGRAM.
      WRITE(IOUT,'(A,I3)') ' RELAX VERSION 1.0, INPUT FROM UNIT',IN
C2------READ NUMBER OF BUDGET ZONES AND UNIT FOR SAVING UNFORMATTED
C2------BUDGET FILE TO BE SAVED IN HYDROGRAPH FORMAT
      READ(IN,'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,STRLX,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,STMIN,IOUT,IN)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,STMAX,IOUT,IN)
      WRITE(IOUT,'(A,F10.6)') ' RELAX FACTOR',STRLX
      WRITE(IOUT,'(A,F10.4)') ' MINIMUM ST  ',STMIN
      WRITE(IOUT,'(A,F10.4)') ' MAXIMUM ST  ',STMAX
C
C3------ALLOCATE MEMORY FOR TEMPORARY HEAD ARRAY
      LCRLX  = ISUMRX
      ISUMRX = ISUMRX + NODES
C
C4------PRINT AMOUNT OF SPACE USED BY THE BUDGET
      WRITE(IOUT,'(1X,I8,A)')
     |  ISUMRX-LCRLX,' ELEMENTS IN RX ARRAY USED FOR RELAX'
C5------RETURN
      END
C**********************************************************************C
C***  Save heads for relaxation                                     ***C
C**********************************************************************C
      SUBROUTINE RELAX1FM(HNEW,HTMP,NODES)
      DOUBLE PRECISION HNEW
      DIMENSION HNEW(NODES),HTMP(NODES)

      do L=1,NODES
        HTMP(L) = HNEW(L)
      enddo
      END
C***********************************************************************
C***  Relax saturated thickness
C***********************************************************************
      SUBROUTINE RELAX1AP(HNEW,HTMP,IBOUND,BOTM,NBOTM,HDRY,
     |  STRLX,STMIN,STMAX,NROW,NCOL,NLAY)
      DOUBLE PRECISION HNEW,HMIN
      DIMENSION HNEW(NCOL,NROW,NLAY),HTMP(NCOL,NROW,NLAY)
      DIMENSION IBOUND(NCOL,NROW,NLAY),BOTM(NCOL,NROW,0:NBOTM)
      COMMON /DISCOM/LBOTM(200),LAYCBD(200)

      do K=1,NLAY
        LK = LBOTM(K)
        do I=1,NROW
          do J=1,NCOL
            if (IBOUND(J,I,K).gt.0                .and.
     |          HNEW(J,I,K).lt.HTMP(J,I,K)        .and.
     |          HNEW(J,I,K).lt.BOTM(J,I,LK)+STMAX) then
              HMIN = MAX(HNEW(J,I,K),BOTM(J,I,LK))
              HNEW(J,I,K) = STRLX*HMIN + (1-STRLX)*HTMP(J,I,K)
              if (HNEW(J,I,K).lt.BOTM(J,I,LK)+STMIN) then
                HNEW(J,I,K) = HDRY
                IBOUND(J,I,K) = 0
              endif
            endif
          enddo
        enddo
      enddo
      END
